Attribute VB_Name = "YClient_05"
' *****************************
'   YClient_05.bas
'   Version 0.5
'
' CONTAINS: All the functions
' and code you need to write a client
' for the Yahoo! Chat network.
'
' LICENSE: Just drop me an email if
' you use this in an application.
' My email address is wraith@planetshogo.com
'
' REQUIREMENTS: VB 6.0, Winsock Control, Rich Text Control,
'               Valid Yahoo! Username/Password
'
' Works with Yahoo! Messenger 5.0 Protocol
'
' NOTE: Not all of this code is mine.
' Let me give credit where credit is
' due.  This contains code written by
' Alfie Pugh (http://www.planet-source-code.com/vb/scripts/ShowCode.asp?txtCodeId=27582&lngWId=1)
' amongst others...I can't remember
' where I got everything, so if you
' see your code here, I'm sorry!
' Drop me a line and I'll add your name
' to the comments of this module.
'
' MORE NOTES: Yes, I know that the
' packet cleaning functions are messy
' and just bulldoze through the data
' blindly. But they work.
'
' USAGE:
' 1) Place a Winsock control on a form.
' 2) Paste the following code into the form,
'    replacing <control> with the name of your
'    Winsock control:
'
' ***********************
' BEGIN YAHOO CLIENT CODE
' ***********************
'Private Sub <control>_Connect()
'  Connected = True
'  If GotCookie = False Then
'    ' Connected to Yahoo! Cookie Server
'  Else
'    ' Connected to Yahoo! Chat Server
'  End If
'End Sub

'Private Sub <control>_DataArrival(ByVal bytesTotal As Long)
'Dim CookieStart As Integer
'Dim CookieEnd As Integer
'Dim datatype As Integer
'<control>.GetData data, vbString
'  If GotCookie = False Then                                       '/ If gotcookie = false then data recieved must be cookie
'    CookieStart = InStr(1, data, "v=")                            '/
'    CookieEnd = InStr(CookieStart + 1, data, ";")                 '/ PARSE COOKIE
'    Cookie = Mid(data, CookieStart, CookieEnd - CookieStart)      '/
'    GotCookie = True
'    <control>.Close
'    LoginToChatServer Username, cServer, 8001
'    Exit Sub
'  End If

'datatype = Asc(Mid(data, Len(Header) + 1, 1))
'HandleData datatype, data
'End Sub
'
'Private Function LoginToChatServer(User As String, Server As String, Port As Integer)
'  LoggedIn = False
'  <control>.Close
'  <control>.Connect Server, Port
'  Connected = False
'  Do While Connected = False
'    DoEvents
'  Loop
'
'    <control>.SendData Header & Chr(1) & Chr(0) & Chr(0) & _
'        CalcSize(Len(User) + Len(Cookie) + 1) & _
'            User & Chr(1) & Cookie
'  Do While LoggedIn = False
'    DoEvents
'  Loop
'
'  ' You are now connected to Yahoo! Chat
'  ' This would be a good place to Join a room.
'
'End Function
'
'Private Function HandleData(datatype As Integer, data As Variant)
'
'    Select Case datatype
'
'      Case 1            'LOGIN
'        LoggedIn = True
'        ' Your Code Here
'      Case 17           'USER ENTERS/JOINED ROOM
'        ' Your Code Here
'        ' Use CleanJoinPacket to get who joined the room.
'      Case 18           'USER LEAVES
'        ' Your Code Here
'        ' Use CleanPartPacket to get who left the room.
'      Case 33           'USER AWAY
'        ' Your Code Here
'      Case 65           'SPEECH
'        ' Your Code Here
'        ' Use CleanSpeechPacket to get chat text.
'      Case 66           'THOUGHT
'        ' Your Code Here
'      Case 67           'EMOTION
'        ' Your Code Here
'        ' Use CleanSpeechPacket to get emote text.
'      Case 68           'ADVERTISMENT
'        ' Your Code Here
'      Case 69           'PM (Instant Message)
'        ' Your Code Here
'        ' Use CleanPMPacket to get instant message text.
'
'   End Select
'End Function
' *********************
' END YAHOO CLIENT CODE
' *********************
'
' 3) Call Init_Yahoo_Connect.
' 4) If everything goes well, you're connected!
'    Join a chat room and have fun.
'
' *****************************

' Variables for Connection process
Global Header As String
Global GotCookie As Boolean
Global LoggedIn As Boolean
Global Connected As Boolean
Global Cookie As String
Global Username As String
Global Password As String
Global cServer As String

' Variables for parsing color
Dim ac_bold As String
Dim ac_underline As String
Dim ac_color As String
Dim Esc As String
Dim ExtractIndicator(), ExtractMove(), ExtractExpirence(), ExtractStyle As String

' ******************
' Init_Yahoo_Connect
' ******************
' Usage:
' Init_Yahoo_Connect MyUsername, MyPass, MyServer, WinsockControl
' This function initiates the connection to Yahoo! Chat.
' Valid servers include:
'   cs1.chat.yahoo.com
'   cs2.chat.yahoo.com
'   cs3.chat.yahoo.com
'   cs4.chat.yahoo.com
'   cs5.chat.yahoo.com
'   cs6.chat.yahoo.com
'   cs7.chat.yahoo.com
'   cs8.chat.yahoo.com
' This function first connects to Yahoo!, grabs a cookie from them,
' parses out the encrypted password from it, and then uses the
' data to connect to a Yahoo! Chat server.

Public Function Init_Yahoo_Connect(mUsername As String, mPassword As String, mServer As String, WS As Winsock)
Header = "YCHT" & Chr(0) & Chr(0) & Chr(1) & Chr(0) & Chr(0) & Chr(0) & Chr(0)
GotCookie = False
WS.Close
WS.Connect "msg.edit.yahoo.com", 80
Connected = False
Do While Connected = False
    DoEvents
Loop
WS.SendData "GET /config/ncclogin?.src=bl&login=" + mUsername + "&passwd=" + mPassword + "&n=1 HTTP/1.0" & _
        vbCrLf & "Accept: */*" & _
            vbCrLf & "Accept: text/html" & vbCrLf & vbCrLf
Username = mUsername
Password = mPassword
cServer = mServer
End Function

' ******************
' SendPrivateMessage
' ******************
' Usage:
' SendPrivateMessage MyText, MyUsername, ToUsername, WinsockControl
' This function sends a Private (Instant) message to a specific user.
Public Function SendPrivateMessage(data As String, Sender As String, Target As String, WS As Winsock)
WS.SendData Header & Chr(69) & Chr(0) & Chr(0) & CalcSize(Len(data) + Len(Sender) + Len(Target) + 2) & Sender & Chr(1) & Target & Chr(1) & data
End Function

' ***********
' SendMessage
' ***********
' Usage:
' SendMessage MyText, MyRoom, WinsockControl
' This function sends chat data to a room.
Public Function SendMessage(data As String, roomtext As String, WS As Winsock)
WS.SendData Header & Chr(65) & Chr(0) & Chr(0) & CalcSize(Len(roomtext) + Len(data) + 16) & roomtext & Chr(1) & data & "KyUaFhCoHoA!T" 'Cheeta: "[$m" Yahelite: '"[~w2~tJDLINFHANFCOAAAA~m"
End Function

' *******
' SetAway
' *******
' Usage:
' SetAway 1, MyUsername, WinsockControl
' Sets the user's away state.
Public Function SetAway(Number As Integer, Username As String, WS As Winsock)
WS.SendData Header & Chr(33) & Chr(0) & Chr(0) & CalcSize(Len(Username)) & Chr(192) & Chr(128) & Number & Chr(192) & Chr(128) '
End Function

' **********
' CustomAway
' **********
' Usage:
' CustomAway MyAwayMessage, MyUsername, WinsockControl
' Sets a custom away message.
Public Function CustomAway(message As String, Username As String, WS As Winsock)
WS.SendData Header & Chr(33) & Chr(0) & Chr(0) & CalcSize(Len(Username) + Len(message)) & Chr(192) & Chr(128) & "10" & Chr(192) & Chr(128) & message '
End Function

' **********
' SendThink
' **********
' Usage:
' SendThink MyText, MyRoom, WinsockControl
' Sends a "thought" to the current channel.
' NOTE: I don't think these are supported. Every time I use
' this I get the "Danger Will Robinson!!!" message.
Public Function SendThink(data As String, roomname As String, WS As Winsock)
WS.SendData Header & Chr(66) & Chr(0) & Chr(0) & CalcSize(Len(roomname) + Len(data) + 16) & roomname & Chr(1) & data & "KyUaFhCoHoA!T" 'Cheeta: "[$m" Yahelite: '"[~w2~tJDLINFHANFCOAAAA~m"
End Function

' *********
' SendEmote
' *********
' Usage:
' SendEmote MyText, MyRoom, Winsock Control
' Sends an Emote to the current room.
Public Function SendEmote(data As String, roomname As String, WS As Winsock)
WS.SendData Header & Chr(67) & Chr(0) & Chr(0) & CalcSize(Len(roomname) + Len(data) + 16) & roomname & Chr(1) & data & "KyUaFhCoHoA!T" 'Cheeta: "[$m" Yahelite: '"[~w2~tJDLINFHANFCOAAAA~m"
End Function

' *********
' Join
' *********
' Usage:
' Join RoomName, WinsockControl
' Joins a Yahoo! Chat room.  If the room doesn't exist, it
' will be created.
Public Function Join(Room As String, WS As Winsock)
WS.SendData Header & Chr(17) & Chr(0) & Chr(0) & CalcSize(Len(Room)) & Room
End Function

' *********
' GotoUser
' *********
' Usage:
' GotoUser Username, WinsockControl
' Joins the given user's room.
Public Function GotoUser(User As String, WS As Winsock)
WS.SendData Header & Chr(37) & Chr(0) & Chr(0) & CalcSize(Len(User)) & User
End Function

' ****
' Ping
' ****
' Usage:
' Ping WinsockControl
' Sends a "ping" packet to Yahoo!. Usefull for keeping
' connections alive.
Public Function Ping(WS As Winsock)
WS.SendData Header & Chr(98) & Chr(0) & Chr(0) & Chr(0) & Chr(0)
End Function

' ******
' LogOut
' ******
' Usage:
' LogOut WinsockControl
' Logs the client out of Yahoo! Chat.
Public Function LogOut(WS As Winsock)
WS.SendData Header & Chr(2) & Chr(0) & Chr(0)
End Function

' ******
' Invite
' ******
' Usage:
' Invite Username, WinsockControl
' Invites a user to your current room.
' NOTE: I can't seem to get this to work.
Public Function Invite(User As String, WS As Winsock)
WS.SendData Header & Chr(23) & Chr(0) & Chr(0) & CalcSize(Len(User)) & User
End Function

' ******
' CalcSize
' ******
' Helper function for packet creation.
Public Function CalcSize(PckLen As Integer) As String
Dim FstNum As String
  FstNum = 0
    Do While PckLen > 255
      FstNum = FstNum + 1
      PckLen = PckLen - 256
    Loop
  CalcSize = Chr$(FstNum) & Chr$(PckLen)
End Function

' Yahoo! Packet Parsing Functions

' *****************
' CleanSpeechPacket
' *****************
' Usage:
' CleanedText = CleanSpeechPacket ( PacketData, True, MyRoom )
' This function pulls the speaker's name and chat text
' from a Speech (Type 65) packet, optionally stripping
' the HTML tags from the text message.
' Returns a colon delimited string in this format:
' <username>:<text>
Public Function CleanSpeechPacket(data As String, StripHTML As Boolean, Room As String) As String
Dim cleaned As String
Dim ChatTag As String
Dim Splitdata() As String
cleaned = Replace(data, Header & Chr(65), "")
cleaned = Mid(cleaned, 5)
cleaned = Replace(cleaned, Room, "")
cleaned = Mid(cleaned, 3)
cleaned = Replace(cleaned, "KyUaFhCoHoA!T", "")
cleaned = Replace(cleaned, "", ":")
If StripHTML Then
    cleaned = stripTag(cleaned, "fade")
    cleaned = stripTag(cleaned, "FADE")
    cleaned = stripTag(cleaned, "font")
    cleaned = stripTag(cleaned, "FONT")
    cleaned = stripTag(cleaned, "b")
    cleaned = stripTag(cleaned, "B")
    cleaned = stripTag(cleaned, "u")
    cleaned = stripTag(cleaned, "U")
    cleaned = stripTag(cleaned, "i")
    cleaned = stripTag(cleaned, "I")
    cleaned = stripTag(cleaned, "alt")
    cleaned = stripTag(cleaned, "ALT")
    cleaned = Replace(cleaned, "<red>", "")
    cleaned = Replace(cleaned, "<RED>", "")
    cleaned = Replace(cleaned, "<blue>", "")
    cleaned = Replace(cleaned, "<BLUE>", "")
    cleaned = Replace(cleaned, "<yellow>", "")
    cleaned = Replace(cleaned, "<YELLOW>", "")
    cleaned = Replace(cleaned, "<green>", "")
    cleaned = Replace(cleaned, "<GREEN>", "")
    cleaned = Replace(cleaned, "<purple>", "")
    cleaned = Replace(cleaned, "<PURPLE>", "")
End If
CleanSpeechPacket = cleaned
End Function

' *************
' CleanPMPacket
' *************
' Usage:
' CleanedText = CleanPMPacket( PacketData, True )
' This function pulls out the speaker's name and chat
' text from a Private Message (Type 69) packet.
' It returns a colon delimited string in this format:
' <username>:<text>
Public Function CleanPMPacket(data As String, StripHTML As Boolean) As String
Dim Splitdata() As String
Dim Sendername As String
Dim message As String
data = Replace(data, Header, "")
Splitdata = Split(data, "")
Sendername = Mid(Splitdata(0), 6)
message = Splitdata(2)
If StripHTML Then
    message = stripTag(message, "fade")
    message = stripTag(message, "FADE")
    message = stripTag(message, "font")
    message = stripTag(message, "FONT")
    message = stripTag(message, "b")
    message = stripTag(message, "B")
    message = stripTag(message, "u")
    message = stripTag(message, "U")
    message = stripTag(message, "i")
    message = stripTag(message, "I")
    message = stripTag(message, "alt")
    message = stripTag(message, "ALT")
    message = Replace(message, "<red>", "")
    message = Replace(message, "<RED>", "")
    message = Replace(message, "<blue>", "")
    message = Replace(message, "<BLUE>", "")
    message = Replace(message, "<yellow>", "")
    message = Replace(message, "<YELLOW>", "")
    message = Replace(message, "<green>", "")
    message = Replace(message, "<GREEN>", "")
    message = Replace(message, "<purple>", "")
    message = Replace(message, "<PURPLE>", "")
End If
CleanPMPacket = Sendername & ":" & message
End Function

' ***************
' CleanPartPacket
' ***************
' Usage:
' CleantedText = CleanPartPacket( PacketData )
' This function extracts the username contained in
' a Part (Type 18) packet.  It returns a string
' containing the username.
Public Function CleanPartPacket(data As String) As String
Dim cleaned As String
Dim Splitdata() As String
cleaned = Replace(data, Header & Chr(18), "")
cleaned = Replace(cleaned, Header, "")
cleaned = Replace(cleaned, "1 00", "")
cleaned = Replace(cleaned, Chr(18), "")
Splitdata = Split(cleaned, "")
CleanPartPacket = Splitdata(1)
End Function

' ***************
' CleanJoinPacket
' ***************
' Usage:
' CleanedText = CleanJoinPacket( PacketData, True )
' This function extracts either the joining user
' OR a colon delimeted string containing the current
' channel userlist that is received when the client
' first joins a room.  Set InitialJoin to True when
' you first join a channel to receive the userlist;
' set it to False the rest of the time to get the
' joining user's username.
' The function will return the string "Error" if
' there's a problem.  This just means the room is full.
Public Function CleanJoinPacket(data As String, InitialJoin As Boolean)
Dim sData() As String
If InitialJoin Then
    Dim tempdata As String
    Dim AdData As String
    Dim cData() As String
    CleanJoinPacket = ""
    tempdata = Replace(data, Header, "")
    tempdata = Mid(tempdata, 1)
    sData = Split(tempdata, "")
    cData = Split(sData(4), "0 00 ")
    For x = 0 To UBound(cData) - 1
        If cData(x) <> "" Then
            If cData(x) <> "0" Then
                CleanJoinPacket = CleanJoinPacket & cData(x) & ":"
            End If
        End If
    Next x
    CleanJoinPacket = Replace(CleanJoinPacket, "1 00 ", ":")
    Exit Function
End If
On Error GoTo audihere
Dim cleaned As String
Dim Splitdata() As String
Dim splitdata2() As String
cleaned = Replace(data, Header & Chr(datatype), "")
Splitdata = Split(cleaned, "")
splitdata2 = Split(Splitdata(4), "0 00")
CleanJoinPacket = splitdata2(0)
CleanJoinPacket = Replace(CleanJoinPacket, Header, "")
CleanJoinPacket = Replace(CleanJoinPacket, Chr(datatype), "")
If InStr(CleanJoinPacket, "1 00 ") = 0 Then
Exit Function
Else
sData = Split(CleanJoinPacket, "1 00 ")
CleanJoinPacket = sData(0)
End If
Exit Function
audihere:
CleanJoinPacket = "Error"
End Function

' HTML Stripping Functions
Public Function stripTag(strHTML As String, tag1 As String) As String
Dim strTagOpen          As String
Dim strTagClose         As String
Dim strTagName          As String
Dim strTagBlock         As String
Dim lngFirstStopPos     As Long
Dim lngNextStartPos     As Long
Dim lngReplacePos       As Long
Dim lngReplaceLength    As Long
Dim n As Long ' Only a counter :)
Dim bProcOK             As Boolean
Dim outString As String
outString = strHTML
    
    strTagName = "<" & tag1
    If tag1 = "a href" Then
        strTagClose = "</a>"
    Else
        strTagClose = "</" & tag1 & ">"
    End If
    lngFirstStopPos = 1
        bProcOK = True
        Do Until Not (bProcOK)
            bProcOK = WordFound(strTagName, outString, lngFirstStopPos)
            If bProcOK Then
                If String_Is_Tag(strTagName, outString, strTagOpen, strTagBlock, lngFirstStopPos, lngReplacePos, lngReplaceLength) Then
                        outString = Replace(outString, strTagOpen, BLANK)
                        outString = Replace(outString, strTagClose, BLANK)
                    End If
                    n = n + 1
                End If
        Loop
     If n = 0 Then
     stripTag = strHTML
     Else
     stripTag = outString
     End If
     
Exit Function

Err_Strip:
    
End Function

Private Function WordFound(strText As String, strHTML As String, _
                            lngStartPos As Long, Optional lngEndPos As Long) As Boolean
Dim FoundPos            As Long
    On Error GoTo Err_WordFound
    FoundPos = InStr(lngStartPos, strHTML, strText)
    If FoundPos > 0 Then
        WordFound = True
        lngStartPos = FoundPos
    Else
        WordFound = False
        lngStartPos = lngStartPos + 1
    End If
Exit Function
Err_WordFound:
End Function
Private Function String_Is_Tag(strString As String, strHTML As String, strTag As String, _
                               strTagBlock As String, lngStartPos As Long, lngReplacePos As Long, _
                               lngLengthOfTag) As Boolean
Dim strRet              As String
Dim StartPos            As Long
Dim intEndPos           As Long
Dim lngBlockEnd         As Long
Dim strBlockCloseTag    As String
    strBlockCloseTag = "</" & Mid(strString, 2, Len(strString)) & ">"
  If WordFound(strString, strHTML, lngStartPos) Then
        StartPos = InStr(lngStartPos, strHTML, strString)
        intEndPos = InStr(StartPos, strHTML, ">")
        lngLengthOfTag = (intEndPos - StartPos) + 1
        lngBlockEnd = InStr(StartPos, strHTML, strBlockCloseTag)
        strRet = Mid(strHTML, StartPos, lngLengthOfTag)
            strTag = strRet
            lngReplacePos = StartPos
            lngStartPos = lngStartPos + lngLengthOfTag
                    strTagBlock = ""
            String_Is_Tag = True
    End If
Exit Function
End Function

' Parsing Yahoo! ANSI-like colored text
'
' ****************
' WriteColoredText
' ****************
' Usage:
' WriteColoredText MyText, RichTextBoxControl
' This function will parse out Yahoo!'s color
' codes from chat text and attempt to write
' them to a Rich Text Box in the appropriate
' colors, followd by a vbNewLine.
' NOTE: Not all of the colors are correct.
'
Public Function WriteColoredText(ansicode As String, rich As RichTextBox)
Dim isEscape As Boolean
Dim sBuffer As String, i As Integer
Dim curChr As String
Dim j As Integer, modes() As String
Dim INFO() As String, RawDATA As String
ansicode = Replace(ansicode, "", "")
ansicode = Replace(ansicode, "", "")
ansicode = Replace(ansicode, "", "")
ansicode = Replace(ansicode, "", "")
ansicode = Replace(ansicode, Chr(13), "")
Esc = Chr(27)
isEscape = False
For i = 1 To Len(ansicode)
    curChr = Mid(ansicode, i, 1)
    If curChr = "[" And isEscape Then GoTo nex
    If curChr = Esc Then
        rich.SelText = sBuffer
        rich.SelStart = Len(rich.Text)
        sBuffer = ""
        isEscape = True
    ElseIf curChr = "m" And isEscape Then
        If sBuffer = "" Then isEscape = False: GoTo nex
        modes = Split(sBuffer, ";")
        For j = LBound(modes) To UBound(modes)
            If IsNumeric(modes(j)) = False Then GoTo nex
            Select Case modes(j)
                Case 0:     If rich.SelBold Then rich.SelBold = False
                Case 4:     If rich.SelUnderline = False Then rich.SelUnderline = True
                Case 30:    rich.SelColor = vbBlack
                Case 38:    rich.SelColor = vbRed
                Case 34:    rich.SelColor = vbGreen
                Case 39:    rich.SelColor = &H8080& ' brown
                Case 31:    rich.SelColor = vbBlue
                Case 36:    rich.SelColor = vbMagenta
                Case 32:    rich.SelColor = vbCyan
                Case 33:    rich.SelColor = &H808080 ' grey
               End Select
        Next j
        sBuffer = ""
        isEscape = False
    Else
        sBuffer = sBuffer & curChr
        If i = Len(ansicode) Then rich.SelText = sBuffer
    End If
nex:
Next i
rich.SelStart = Len(rich.Text)
rich.SelText = vbNewLine
rich.SelBold = False
rich.SelItalic = False
rich.SelUnderline = False
End Function

